import java.applet.Applet;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Toolkit;

public class MkDraw {
	static Image BackBufferImage;
	static Graphics2D BackBuffer;
	static Applet app;
	private static int fps, fpscount;
	private static long nowtime_old = 0;
	static Image[] SpImage = new Image[8];
	static int offset_x = 0;
	static int width, height;

	public MkDraw(){}
	public MkDraw(int Width, int Height, Applet App){
		app = App;
		width = Width;
		height = Height;
		BackBufferImage = app.createImage(width, height);
		BackBuffer = (Graphics2D)BackBufferImage.getGraphics();
		SpImage[0] = Toolkit.getDefaultToolkit().getImage(getClass().getResource("img/parts.gif"));
		SpImage[1] = Toolkit.getDefaultToolkit().getImage(getClass().getResource("img/shadow.png"));
		SpImage[2] = Toolkit.getDefaultToolkit().getImage(getClass().getResource("img/bg1.png"));
		SpImage[3] = Toolkit.getDefaultToolkit().getImage(getClass().getResource("img/bg2.png"));
		SpImage[4] = Toolkit.getDefaultToolkit().getImage(getClass().getResource("img/bg3.png"));
		SpImage[5] = Toolkit.getDefaultToolkit().getImage(getClass().getResource("img/bg4.png"));
	}
	public void DrawImage(int imgno, int x, int y, int w, int h, int x2, int y2, int w2, int h2){
		x += offset_x;
		BackBuffer.drawImage(SpImage[imgno], x, y, x+w, y+h, x2, y2, x2+w2, y2+h2, app);
	}
	public void DrawImageNormal(int imgno, int x, int y, int w, int h, int x2, int y2, int w2, int h2){
		BackBuffer.drawImage(SpImage[imgno], x, y, x+w, y+h, x2, y2, x2+w2, y2+h2, app);
	}
	public Graphics2D GetG2D(){
		return BackBuffer;
	}
	public static void FpsCount(long Nowtime){
		if(Nowtime >= nowtime_old+1000){
			fps = fpscount;
			fpscount = 0;
			nowtime_old = 0;
		}
		if(nowtime_old == 0){
			nowtime_old = Nowtime;
		}
		fpscount++;
	}
	public long GetFps(){
		return fps;
	}
	public static void SyncRedraw(){
		try {
			Graphics2D g = (Graphics2D)app.getGraphics(); // OtBbNIuWFNg擾
			if ((g != null) && (BackBufferImage != null)) {
				g.drawImage(BackBufferImage, 0, 0, MkApplet.width, MkApplet.height, null); // obt@C[Wʂɕ`
			}
			Toolkit.getDefaultToolkit().sync();
			if (g != null) {
				g.dispose(); // OtBbNIuWFNgj
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
