import java.applet.Applet;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public class MkInput implements KeyListener ,MouseListener ,MouseMotionListener{
	static int up = 0;
	static int down = 0;
	static int left  = 0;
	static int right = 0;
	static int button[] = { 0, 0, 0, 0 };

	static boolean fUp = false;
	static boolean fDown = false;
	static boolean fLeft  = false;
	static boolean fRight = false;
	static boolean fButton[] = { false, false, false, false };
	
	static int mouse = 0;
	static int mouser = 0;
	static boolean fMouse = false;
	static boolean fMouser = false;
	static boolean fDragged = false;
	static int mX = 0 , mY = 0;
	
	public MkInput(Applet app){
		app.requestFocus();
		app.addKeyListener(this);
		app.addMouseListener(this);
		app.addMouseMotionListener(this);
	}
	public void keyPressed(KeyEvent e) {
		switch(e.getKeyCode()){
		case KeyEvent.VK_UP:
			fUp = true;
			break;
		case KeyEvent.VK_DOWN:
			fDown = true;
			break;
		case KeyEvent.VK_LEFT:
			fLeft = true;
			break;
		case KeyEvent.VK_RIGHT:
			fRight = true;
			break;
		case KeyEvent.VK_Z:
			fButton[0] = true;
			break;
		case KeyEvent.VK_X:
			fButton[1] = true;
			break;
		case KeyEvent.VK_C:
			fButton[2] = true;
			break;
		case KeyEvent.VK_V:
			fButton[3] = true;
			break;
		default:
			break;
		}
	}
	public void keyReleased(KeyEvent e) {
		switch(e.getKeyCode()){
		case KeyEvent.VK_UP:
			fUp = false;
			break;
		case KeyEvent.VK_DOWN:
			fDown = false;
			break;
		case KeyEvent.VK_LEFT:
			fLeft = false;
			break;
		case KeyEvent.VK_RIGHT:
			fRight = false;
			break;
		case KeyEvent.VK_Z:
			fButton[0] = false;
			break;
		case KeyEvent.VK_X:
			fButton[1] = false;
			break;
		case KeyEvent.VK_C:
			fButton[2] = false;
			break;
		case KeyEvent.VK_V:
			fButton[3] = false;
			break;
		default:
			break;
		}
	}
	public void keyTyped(KeyEvent e) {	};
	public static void IncrementKeyState(){
		if(fUp){
			up++;
		}else{
			up=0;
		}
		if(fDown){
			down++;
		}else{
			down=0;
		}
		if(fLeft){
			left++;
		}else{
			left=0;
		}
		if(fRight){
			right++;
		}else{
			right=0;
		}
		if(fButton[0]){
			button[0]++;
		}else{
			button[0]=0;
		}
		if(fButton[1]){
			button[1]++;
		}else{
			button[1]=0;
		}
		if(fButton[2]){
			button[2]++;
		}else{
			button[2]=0;
		}
		if(fButton[3]){
			button[3]++;
		}else{
			button[3]=0;
		}
		if( fMouse ){
			mouse++;
		}else{
			mouse = 0;
		}
		if( fMouser ){
			mouser++;
		}else{
			mouser = 0;
		}
	}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {
		if(javax.swing.SwingUtilities.isRightMouseButton(e)){
		// ENbN̏
			fMouser = true;
		}else if(javax.swing.SwingUtilities.isMiddleMouseButton(e)){
		// {^NbN̏
		}else if(javax.swing.SwingUtilities.isLeftMouseButton(e)){
		// NbN̏
			fMouse = true;
		}
	}
	public void mouseReleased(MouseEvent e) {
		if(javax.swing.SwingUtilities.isRightMouseButton(e)){
			fMouser = false;
		}else if(javax.swing.SwingUtilities.isMiddleMouseButton(e)){
		}else if(javax.swing.SwingUtilities.isLeftMouseButton(e)){
			fMouse = false;
		}
	}
	public void mouseDragged(MouseEvent e) {
		mX = e.getX()/2;
		mY = e.getY()/2;
		fDragged = true;
	}
	public void mouseMoved(MouseEvent e) {
		mX = e.getX()/2;
		mY = e.getY()/2;
		fDragged = false;
	}
}
