import java.applet.Applet;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class MkKey implements KeyListener{
	static int up = 0;
	static int down = 0;
	static int left  = 0;
	static int right = 0;
	static int button[] = { 0, 0, 0, 0 };

	static boolean fUp = false;
	static boolean fDown = false;
	static boolean fLeft  = false;
	static boolean fRight = false;
	static boolean fButton[] = { false, false, false, false };
	
	public MkKey(Applet app){
		app.addKeyListener(this);
	}
	public void keyPressed(KeyEvent e) {
		switch(e.getKeyCode()){
		case KeyEvent.VK_UP:
			fUp = true;
			break;
		case KeyEvent.VK_DOWN:
			fDown = true;
			break;
		case KeyEvent.VK_LEFT:
			fLeft = true;
			break;
		case KeyEvent.VK_RIGHT:
			fRight = true;
			break;
		case KeyEvent.VK_Z:
			fButton[0] = true;
			break;
		case KeyEvent.VK_X:
			fButton[1] = true;
			break;
		case KeyEvent.VK_C:
			fButton[2] = true;
			break;
		case KeyEvent.VK_V:
			fButton[3] = true;
			break;
		default:
			break;
		}
	}
	public void keyReleased(KeyEvent e) {
		switch(e.getKeyCode()){
		case KeyEvent.VK_UP:
			fUp = false;
			break;
		case KeyEvent.VK_DOWN:
			fDown = false;
			break;
		case KeyEvent.VK_LEFT:
			fLeft = false;
			break;
		case KeyEvent.VK_RIGHT:
			fRight = false;
			break;
		case KeyEvent.VK_Z:
			fButton[0] = false;
			break;
		case KeyEvent.VK_X:
			fButton[1] = false;
			break;
		case KeyEvent.VK_C:
			fButton[2] = false;
			break;
		case KeyEvent.VK_V:
			fButton[3] = false;
			break;
		default:
			break;
		}
	}
	public void keyTyped(KeyEvent e) {	};
	public static void IncrementKeyState(){
		if(fUp){
			up++;
		}else{
			up=0;
		}
		if(fDown){
			down++;
		}else{
			down=0;
		}
		if(fLeft){
			left++;
		}else{
			left=0;
		}
		if(fRight){
			right++;
		}else{
			right=0;
		}
		if(fButton[0]){
			button[0]++;
		}else{
			button[0]=0;
		}
		if(fButton[1]){
			button[1]++;
		}else{
			button[1]=0;
		}
		if(fButton[2]){
			button[2]++;
		}else{
			button[2]=0;
		}
		if(fButton[3]){
			button[3]++;
		}else{
			button[3]=0;
		}
	}
}
