import java.io.IOException;
import java.util.HashMap;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

/*
 * Created on 2006/11/05
 */

public class MkWave implements LineListener {
    // o^łWAVEt@C̍ő吔
    static private int maxClips;
    // WAVEt@Cf[^iO->f[^{́j
    static private HashMap clipMap;
    // o^ꂽWAVEt@C
    static private int counter = 0;

    /**
     * RXgN^
     */
    public MkWave() {}

    /**
     * RXgN^
     * 
     * @param maxClips
     *            o^łWAVEt@C̍ő吔
     * @return 
     */
    public static void Initialize(int MaxClips) {
        maxClips = MaxClips;
        clipMap = new HashMap(maxClips);
    }

    /**
     * WAVEt@C[h
     * @param name o^
     * @param filename t@C
     */
	@SuppressWarnings("unchecked")
	public void load(String name, String filename) {
        if (counter == maxClips) {
            System.out.println("G[: ȏo^ł܂");
            return;
        }

        try {
            // I[fBIXg[J
            AudioInputStream stream = AudioSystem
                    .getAudioInputStream(getClass().getResource(filename));

            // I[fBI`擾
            AudioFormat format = stream.getFormat();
            // ULAW/ALAW`̏ꍇPCM`ɕύX
            if ((format.getEncoding() == AudioFormat.Encoding.ULAW)
                    || (format.getEncoding() == AudioFormat.Encoding.ALAW)) {
                AudioFormat newFormat = new AudioFormat(
                        AudioFormat.Encoding.PCM_SIGNED,
                        format.getSampleRate(),
                        format.getSampleSizeInBits() * 2, format.getChannels(),
                        format.getFrameSize() * 2, format.getFrameRate(), true);
                stream = AudioSystem.getAudioInputStream(newFormat, stream);
                format = newFormat;
            }

            // C擾
            DataLine.Info info = new DataLine.Info(Clip.class, format);
            // T|[gĂ``FbN
            if (!AudioSystem.isLineSupported(info)) {
                System.out.println("G[: " + filename + "̓T|[gĂȂ`ł");
                System.exit(0);
            }

            // ̃Nbv쐬
            Clip clip = (Clip) AudioSystem.getLine(info);
            // NbṽCxgĎ
            clip.addLineListener(this);
            // I[fBIXg[NbvƂĊJ
            clip.open(stream);
            // Nbvo^
            clipMap.put(name, clip);
            // Xg[
            stream.close();
        } catch (UnsupportedAudioFileException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (LineUnavailableException e) {
            e.printStackTrace();
        }
    }

    /**
     * Đ
     * @param name o^
     */
    public void play(String name) {
        // OɑΉNbv擾
        Clip clip = (Clip)clipMap.get(name);
        if (clip != null) {
        	clip.stop();
        	clip.setFramePosition(0);
            clip.start();
        }
    }
    public void update(LineEvent event) {/*
        // XgbvŌ܂ōĐꂽꍇ
        if (event.getType() == LineEvent.Type.STOP) {
            Clip clip = (Clip) event.getSource();
            clip.stop();
            clip.setFramePosition(0); // Đʒuŏɖ߂
        }*/
    }
}
